function z = bestApprox(X,k,extra)
%BESTAPPROXRCSPD    Approximate a matrix i
%
%  z = bestApproxRcSpd(X,k) calculates the best approximation 
%  of a matrix X in the set of matrices of rank <= k.
%
%  Returns z with z.U*diag(z.sigma)*z.V' the best approximation.
%
%  Direct method with cubic complexity


[U,S,V] = svd(X);

z.U = U(:,1:k);
z.V = V(:,1:k);
z.sigma = diag(S(1:k,1:k));
