function tmin = exact_search_onR1(prob, x,dir)

% Exact line search in the direction of dir on the tangent space of x
% !! so NOT the retracted curve, only use as guess !!

% x, current point

% dir is search direction
%
% returns: tmin
if isfield(prob,'perp_to_U')
    Uperp = prob.perp_to_U;
    Vperp = prob.perp_to_V;

    
    x.on_omega = partXY(diag(x.sigma)*(Uperp*x.U)',(Uperp*x.V)', prob.Omega_i, prob.Omega_j, prob.m)'; 
    f0_omega = x.on_omega - prob.data;
    % beware: transposed!
    Sinv = diag(1./x.sigma);

    
    f1_omega = partXY([Uperp*x.U*dir.M+dir.Up Uperp*x.U]',[Vperp*x.V dir.Vp]', prob.Omega_i, prob.Omega_j, prob.m)'; 
    f2_omega = partXY([Uperp*x.U*dir.M*Sinv dir.Up*Sinv]',...
    [0.25*Vperp*x.V*dir.M'+0.5*dir.Vp  0.5*Vperp*x.V*dir.M'+dir.Vp]', prob.Omega_i, prob.Omega_j, prob.m)'; 

else
    x.on_omega = partXY(diag(x.sigma)*x.U',x.V', prob.Omega_i, prob.Omega_j, prob.m)'; 
    f0_omega = x.on_omega - prob.data;
    % beware: transposed!
    Sinv = diag(1./x.sigma);

    
    f1_omega = partXY([x.U*dir.M+dir.Up x.U]',[x.V dir.Vp]', prob.Omega_i, prob.Omega_j, prob.m)'; 
    f2_omega = partXY([x.U*dir.M*Sinv dir.Up*Sinv]',...
    [0.25*x.V*dir.M'+0.5*dir.Vp  0.5*x.V*dir.M'+dir.Vp]', prob.Omega_i, prob.Omega_j, prob.m)'; 

end


a0 = f1_omega'*f0_omega;
a1 = f1_omega'*f1_omega + 2*(f2_omega'*f0_omega);
a2 = 3*(f1_omega'*f2_omega);
a3 = 2*(f2_omega'*f2_omega);

ts = roots([a3 a2 a1 a0]);
ind_real = find(ts==real(ts));
ts = ts(ind_real);
ind_real = find(ts>0);
if length(ind_real)~=1
    ts_real = ts
    tmin = max(ts(ind_real));
else
    tmin = ts(ind_real);
end
