function st = exact_search_onR1_2dsubspace(prob, x, dir1, dir2)

% Exact line search in the direction of dir on the tangent space of x
% !! so NOT the retracted curve, only use as guess !!

% x, current point

% dir is search direction
%
% returns: tmin

f0_omega = x.on_omega - prob.data;

f1_omega = partXY([x.U*dir1.M+dir1.Up x.U]',[x.V dir1.Vp]', prob.Omega_i, prob.Omega_j, prob.m)'; 
ft1_omega = partXY([x.U*dir2.M+dir2.Up x.U]',[x.V dir2.Vp]', prob.Omega_i, prob.Omega_j, prob.m)'; 

a00 = f1_omega'*f0_omega;
a10 = f1_omega'*f1_omega;
a01 = f1_omega'*ft1_omega + ft1_omega'*f0_omega;
a11 = ft1_omega'*f1_omega;
a02 = ft1_omega'*ft1_omega;

b00 = ft1_omega'*f0_omega;
b10 = ft1_omega'*f1_omega + f1_omega'*f0_omega; 
b01 = ft1_omega'*ft1_omega;
b11 = ft1_omega'*f1_omega;
b20 = f1_omega'*f1_omega;

function r = fun(st)
    s = st(1); t = st(2);
    r(1) = a00 + a10*t + a01*s + a11*s*t + a02*s*s;
    r(2) = b00 + b10*t + b01*s + b11*s*t + b20*t*t;
end
options = optimset('TolFun',1e-10);
st = fsolve(@fun,[10,10],options);
fun(st)
st
pause
return
ts = roots([a3 a2 a1 a0]);
ind_real = find(ts==real(ts));
ts = ts(ind_real);
ind_real = find(ts>0);
if length(ind_real)~=1
    ts
    pause
else
    tmin = ts(ind_real);
end
end