function tmin = exact_search_onlyTxM_multiple(prob, x,dirs)

% Exact line search in the direction of dir on the tangent space of x
% !! so NOT the retracted curve, only use as guess !!
% Multiple dirs

% x, current point

% {dirs} is a series of search directions
%
% returns: tmin

if isfield(prob,'perp_to_U')
    Uperp = prob.perp_to_U;
    Vperp = prob.perp_to_V;
    
    x.on_omega = partXY( (Uperp(x.U*diag(x.sigma)))',(Vperp(x.V))', prob.Omega_i, prob.Omega_j, prob.m)'; 
    b = prob.data - x.on_omega;
    A = zeros(length(b),length(dirs));
    for i=1:length(dirs)
        A(:,i) = partXY([Uperp(x.U*dirs{i}.M+dirs{i}.Up) Uperp(x.U)]',[Vperp(x.V) Vperp(dirs{i}.Vp)]', prob.Omega_i, prob.Omega_j, prob.m);     
    end

    
else
    
    b = prob.data - x.on_omega;
    A = zeros(length(b),length(dirs));
    for i=1:length(dirs)
        A(:,i) = partXY([x.U*dirs{i}.M+dirs{i}.Up x.U]',[x.V dirs{i}.Vp]', prob.Omega_i, prob.Omega_j, prob.m);     
    end

end

tmin = A\b;

