function g = grad(prob,x)
%GRAD   Computes the gradient on the manifold
%
%  Computes the gradient at a point x of the cost function on 
%  the manifold.



%G = sparse(prob.Omega_i, prob.Omega_j, ...
%    x.on_omega - prob.data, prob.n1, prob.n2, prob.m);

    

if isfield(prob,'perp_to_U')
    Uperp = prob.perp_to_U;
    Vperp = prob.perp_to_V;
    %x.on_omega = partXY( (Uperp(x.U*diag(x.sigma)))',(Vperp(x.V))', prob.Omega_i, prob.Omega_j, prob.m)'; % Bart
    x.on_omega = proj_omega_sub( (Uperp(x.U*diag(x.sigma))),(Vperp(x.V)), prob.Omega_i, prob.Omega_j)'; % trying for comparison

    d = x.on_omega - prob.data;
%     updateSval(prob.temp_omega, d, length(d));
    updateSparse(prob.temp_omega, d);
    prob.temp_omega = Vperp( (Uperp(prob.temp_omega))' )';
else
    d = x.on_omega - prob.data;
%     updateSval(prob.temp_omega, d, length(d));
    updateSparse(prob.temp_omega, d);

    prob.temp_omega = prob.temp_omega;
end


T = prob.temp_omega*x.V;
g.M = x.U'*T;   %  + prob.mu*eye(prob.k) ;
g.Up = T - x.U*(x.U'*T);
g.Vp = prob.temp_omega'*x.U; 
g.Vp = g.Vp - x.V*(x.V'*g.Vp);


    
    

