function z = moveEIG(prob, x,h,t,extra)
%MOVEEIG  Retract a point x+t*h (minimal distance)
%
%  z = moveEIG(sys, x,h,t) retracts x+t*h to the manifold where
%   sys is a system,
%     x is a point of sys,
%     h is a tangent vector of TxM,
%     t is a distance (scalar).
%  Retraction is the shortest distance to the manifold.
%
%  Implemented as a partitioned eigenvalue decomposition with 
%  complexity O(k^3 n).

%z = moveR1(prob, x,h,t);
%return

if nargin == 4
    extra = 0;
end

kc = size(x.V,2);



% h = scaleTxM(h,t);
% Sinv = diag(1./x.sigma);
% S2 = diag(sqrt(x.sigma));
% S2inv = diag(1./sqrt(x.sigma));
% 
% Ut = x.U*(S2 + 0.5*h.M*S2inv - 0.125*h.M*Sinv*h.M*S2inv);
% Vt = x.V*(S2 + 0.5*h.M'*S2inv - 0.125*h.M'*Sinv*h.M'*S2inv);
% Ut = Ut + h.Up*(S2inv - 0.5*Sinv*h.M*S2inv);
% Vt = Vt + h.Vp*(S2inv - 0.5*Sinv*h.M'*S2inv);
% 
% [U_t,Ru] = qr(Ut,0);
% [V_t,Rv] = qr(Vt,0);
% [U,S,V] = svd(Ru*Rv');
% z.U = U_t * U;
% z.V = V_t * V;
% z.sigma = diag(S);
% z = prepx(prob, z);
% return

% svd of both

% [U_t,Ru,U2] = svd([x.U t*h.Up],0);
% [V_t,Rv,V2] = svd([x.V t*h.Vp],0);
% Ru_M_Rv = Ru*U2'*[diag(x.sigma)+t*h.M eye(kc); eye(kc) zeros(kc)]*V2*Rv';
% tk = bestApprox(Ru_M_Rv,kc,extra);
% z.U = U_t*tk.U;
% z.V = V_t*tk.V;
% z.sigma = tk.sigma;
% z = prepx(prob, z);
% 
% return


% qr of Vp and Up only
[U_t,Ru] = qr(t*h.Up,0);
[V_t,Rv] = qr(t*h.Vp,0);


Ru_M_Rv = [diag(x.sigma)+t*h.M Rv'; Ru zeros(kc)];
tk = bestApprox(Ru_M_Rv,kc,extra);
z.U = [x.U U_t]*tk.U;
z.V = [x.V V_t]*tk.V;
z.sigma = tk.sigma;
%norm(z.U'*z.U-eye(kc),'fro')
%norm(z.V'*z.V-eye(kc),'fro')

z = prepx(prob, z);