function ht = transpVect2(prob, x,h, t_end,dir)
%TRANSPVECT  transport the vector (x,h) along the direction of d
% type == 0: transpVect(x,h,d)
%    we transport by projecting h orth. on R_x(d)
% type == 1: transpVect(x,h,z)
%    we transport by projecting h orth. on z
% returns ht, the transported h

ts = linspace(0,t_end,5);
ts = ts(1:end);
xc_i = x;
ht_i = h;

for i=1:length(ts)
    t = ts(i);
    xc_new_i = moveEIG(prob,x,dir,t);
    ht_i = transpVect(prob,xc_i,ht_i,xc_new_i,1);
    xc_i = xc_new_i;
end

ht = ht_i;