function [X,out] = LMaFit_common(M,par)
%common interface for LMaFit
clear X;

options = options_default('LMaFit',M);
options.print = 2;

if nargin == 2
    if isfield(par,'maxiter'); options.maxit = par.maxiter; end
    if isfield(par,'tol'); options.tol = par.tol; end
    if isfield(par,'est_rank'); options.est_rank = par.est_rank; end
    if isfield(par,'rank'); options.rank = par.rank; 
    elseif isfield(par,'est_type'); options.rank = rank_est(M,par.est_type); 
    else options.rank = rank_est(M,options.est_type); 
    end
end
t = tic;    
[X.left,X.right,output] = lmafit_mc_adp(M.size1,M.size2,options.rank,M.ind_Omega,M.values_Omega,options);
out.time = toc(t);

X.right = X.right';
out.numiter = output.iter;
out.rank = output.rank;

