function [X,out] = geom_cg_common(M,par)
%common interface for geometric CG
clear X;
options = options_default('GEOM_CG',M);

if nargin == 2
    if isfield(par,'rank'); options.rank = par.rank; 
    elseif isfield(par,'est_type'); options.rank = rank_est(M,par.est_type); 
    else options.rank = rank_est(M,options.est_type); 
    end
    if isfield(par,'maxiter'); options.maxit = par.maxiter; end
    if isfield(par,'tol'); options.rel_f_tol = par.tol; end
    if isfield(par,'rel_grad_tol'); options.rel_grad_tol = par.rel_grad_tol; end
end

[prob,x] = translate_prob(M,options.rank,1);
if nargin == 2
    if isfield(par,'x0'); x0 = par.x0;  else x0 = x; end
end
x0 = prepx(prob, x0);
    
t=tic;
[X,hist] = geom_cg(prob,options,x0);
out.time = toc(t);
out.numiter = size(hist,1);
out.beta = hist(:,3)';
out.grads = hist(:,1);
out.res_omega = hist(:,2)/max(1,norm(M.values_Omega));
%out.res_omega = hist(:,2)/hist(1,2);
out.all_times = hist(:,5);
out.reschg = hist(:,4);


X.S = diag(X.sigma);