function [X,out] = geom_gn_common(M,par)
%common interface for geometric CG
clear X;
options = options_default('GEOM_GN',M);

if nargin == 2
    if isfield(par,'rank'); options.rank = par.rank; 
    elseif isfield(par,'est_type'); options.rank = rank_est(M,par.est_type); 
    else options.rank = rank_est(M,options.est_type); 
    end
    if isfield(par,'maxiter'); options.maxit = par.maxiter; end
    if isfield(par,'tol'); options.rel_f_tol = par.tol; end
end

[prob,x] = translate_prob(M,options.rank,1);

t=tic;
[X, stats] = gn_rank(prob,options,x);
out.time = toc(t);
out.numiter = length([stats.k]);


X.S = diag(X.sigma);