function options = options_default(solver, M)
%default parameters 

if strcmpi(solver, 'SVT')
    n_1 = M.size1;
    n_2 = M.size2;
    m = length(M.ind_Omega);
    options.tau = 2.5*(n_1+n_2);
    options.delta = 1.2*n_1*n_2/m;
    options.maxiter = [];
    options.tol = [];
    options.eps = [];

elseif strcmpi(solver, 'OptSpace')
    options.rank = [];
    options.maxiter = [];
    options.tol = [];
    options.lambda = 0.0;
    
elseif strcmpi(solver, 'IALM')
    options.maxiter = -1;
    options.tol = -1;
    options.proj = 0;
    
elseif strcmpi(solver, 'APGL')
    options.continuation_scaling = 1e-4; 
    options.mutarget = options.continuation_scaling*norm(M.values_Omega);
    options.rhotarget = 0.0; 
 
elseif strcmpi(solver, 'EALM')
    options.maxiter = -1;
    options.tol = -1; 
    options.innertol = 1e-3;
    options.innermaxiter = 50;

elseif strcmpi(solver, 'SET')
    options.tol = 1e-4;  
         
elseif strcmpi(solver, 'GROUSE')
    options.step_size = 0.1;   
    options.maxiter = 100;   
    
elseif strcmpi(solver, 'GEOM_CG')
    options.abs_f_tol = 0;
    options.rel_grad_tol = 0;
    %options.rel_f_tol = 1e-4;
    options.maxit = 500;
    options.nb_k = 1;
    options.verbosity = 0;

elseif strcmpi(solver, 'GEOM_GN')
    options.abs_f_tol = 0;
    options.abs_grad_tol = 0;
    %options.rel_f_tol = 1e-4;
    options.maxit = 100;
    options.nb_k = 1;
    options.verbosity = 1;
    
elseif strcmpi(solver, 'GEOM_RTR')
    options.abs_f_tol = 0;
    options.abs_grad_tol = 0;
    %options.rel_f_tol = 1e-4;
    options.maxit = 100;
    options.nb_k = 1;
    options.verbosity = 1;    
    
elseif strcmpi(solver, 'GEOM_steep')
    options.abs_f_tol = 0;
    options.abs_grad_tol = 0;
    %options.rel_f_tol = 1e-4;
    options.maxit = 500;
    options.nb_k = 1;
    options.verbosity = 0;    
    
elseif strcmpi(solver, 'LMaFit')
    options.maxit = 100;  
    options.tol = 1e-4; 
    options.est_rank = 2; 
    

end
if strcmpi(solver, 'SET') || strcmpi(solver, 'OptSpace') || strcmpi(solver, 'GROUSE') || strcmpi(solver, 'LMaFit') || strcmpi(solver, 'GEOM_CG') || strcmpi(solver, 'GEOM_GN') || strcmpi(solver, 'GEOM_steep') || strcmpi(solver, 'GEOM_RTR')
    options.est_type = 2;
end




