function s = SetDefaultParams(s, p)
% s = SetDefaultParams(s);
% Sets default parameters
% s: user-specified parameters that are used instead of defaults
%Written by: Prateek Jain (pjain@cs.utexas.edu) and Raghu Meka (raghu@cs.utexas.edu)
%Last updated: October, 2009

if (isfield(s, 'step_type') == 0),
    s.step_type = 'armijo';
end

if (isfield(s, 'sigma_armijo') == 0),
    s.sigma_armijo = 0.5;
end

if (isfield(s, 'max_step') == 0),
    s.max_step = 10;
end

if (isfield(s, 'min_iter') == 0),
    s.min_iter = 3;
end

if (isfield(s, 'tol') == 0),
    s.tol = 1e-5;
end

if (isfield(s, 'vtol') == 0),
    s.vtol = 1e-5;
end

if (isfield(s,'maxtol')==0),
    s.maxtol=1e+3;
end

if (isfield(s, 'mxitr') == 0),
    s.mxitr = 10000;
end

if (isfield(s, 'verbosity') == 0),
    s.verbosity = 1;
end

if (isfield(s, 'delta') == 0),
    s.delta = 1 / 3;
end

if (isfield(s, 'step_size') == 0),
    s.step_size= 1 / ((1 + s.delta ) * p);
end

if (isfield(s, 'verb') == 0),
    s.verb = 1;
end

if (isfield(s, 'stopc') == 0),
    s.stopc = 'default';
end

if (isfield(s, 'decreaselr') == 0),
    s.decreaselr = false;
end
