#include "mex.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
	int flag_complex;
	int k, p, tidx_row, tidx_col;
	int *idx_row, *idx_col;
	double *idx_row_d, *idx_col_d;
	double *ur, *ui, *vr, *vi, *yr, *yi;
    
    /* Check I/O number */
    if (nrhs!=5) {
        mexErrMsgTxt("Incorrect number of inputs");
    }

	if( mxIsComplex(prhs[3]) || mxIsComplex(prhs[4]))
		flag_complex = 1;
	else
		flag_complex = 0;

	/* Allocate output */
	if (flag_complex == 1)
		plhs[0] = mxCreateDoubleMatrix(mxGetScalar(prhs[2]), 1, mxCOMPLEX);
	else
		plhs[0] = mxCreateDoubleMatrix(mxGetScalar(prhs[2]), 1, mxREAL);
    
    idx_row_d = mxGetPr(prhs[0]);
    idx_col_d = mxGetPr(prhs[1]);
	p = mxGetScalar(prhs[2]);

	idx_row = (int *) mxCalloc(p, sizeof(int));
	idx_col = (int *) mxCalloc(p, sizeof(int));

	for (k=0; k<p; k++)
	{
		idx_row[k] = (int) idx_row_d[k];
		idx_col[k] = (int) idx_col_d[k];
	}

    ur = mxGetPr(prhs[3]);
    vr = mxGetPr(prhs[4]);
	yr = mxGetPr(plhs[0]);
	if (flag_complex == 0)
	{	    
		for (k=0; k<p; k++)
		{
			tidx_row = (int) idx_row[k] - 1;
			tidx_col = (int) idx_col[k] - 1;
			yr[k] = ur[tidx_row] * vr[tidx_col];
		}
	}
	else
	{
		ui = mxGetPi(prhs[3]);
		vi = mxGetPi(prhs[4]);
		yi = mxGetPi(plhs[0]);
		for (k=0; k<p; k++)
		{
			tidx_row = idx_row[k] - 1;
			tidx_col = idx_col[k] - 1;
			yr[k] = ur[tidx_row] * vr[tidx_col] + ui[tidx_row] * vi[tidx_col];
			yi[k] = ui[tidx_row] * vr[tidx_col] - ur[tidx_row] * vi[tidx_col];
		}
	}
    
    /* End */
}
